<script lang="ts">
import Vue, { PropType } from 'vue';
import { CtfEntry, CtfTheSourceArticlePage } from '~/models';
import { getUrlFromContentfulImage } from '~/common/util';
import { IsMobileMixin } from '~/mixins';
import { THE_SOURCE_TYPES } from '~/common/constants';

export default Vue.extend({
  name: 'TheSourceArticlesList',
  mixins: [IsMobileMixin],
  props: {
    disableAuthor: {
      type: Boolean,
      default: false,
    },
    disableCategory: {
      type: Boolean,
      default: false,
    },
    articles: {
      type: Array as PropType<CtfEntry<CtfTheSourceArticlePage>[]>,
      required: true,
    },
  },
  data() {
    return {
      showAll: false,
      visibleArticles: [],
      allArticles: [],
      types: THE_SOURCE_TYPES,
    };
  },
  beforeMount() {
    this.allArticles = this.articles.map((article) => ({
      ...article,
      isHighlighted: false,
    }));

    this.showAll = this.allArticles.length < 6;
    this.visibleArticles = this.allArticles.slice(0, 6);
  },
  methods: {
    getArticleImage(article: CtfEntry<CtfTheSourceArticlePage>) {
      return getUrlFromContentfulImage(article.fields.heroImage, 340, 180);
    },
    getAlt(article: CtfEntry<CtfTheSourceArticlePage>) {
      return article.fields?.heroImage?.fields?.description;
    },
    toggleArticles() {
      this.showAll = true;
      this.visibleArticles = [...this.allArticles];
    },
  },
});
</script>

<template>
  <div class="ts-articles">
    <div>
      <div
        v-for="(article, index) in visibleArticles"
        :key="`${article.sys.id}-${index}`"
        class="ts-articles__item"
      >
        <div class="slp-mr-16">
          <div class="slp-flex">
            <SlpIcon
              v-if="article.fields.type !== types.REGULAR"
              name="lock"
              variant="product"
              class="slp-mr-4"
            />
            <SlpTypography tag="h5" variant="all-caps">{{
              $t(`articles.${article.fields.type?.toLowerCase()}`)
            }}</SlpTypography>
          </div>
          <SlpButton
            :href="`/${article.fields.slug}/`"
            variant="tertiary"
            :class="[
              'ts-articles__headline',
              { 'ts-articles__headline--active': article.isHighlighted },
            ]"
          >
            <SlpTypography
              tag="h2"
              class="slp-mb-8"
              :variant="`${isMobile ? 'body1-bold' : 'heading5-bold'}`"
              >{{ article.fields?.headline }}
            </SlpTypography>
          </SlpButton>
          <div class="ts-articles__btn-group">
            <SlpButton
              v-if="article.fields.category"
              :href="`/${article.fields.category.fields.slug}/`"
              variant="tertiary"
              :disabled="disableCategory"
            >
              <SlpTypography
                tag="span"
                :variant="`${disableCategory ? 'body3' : 'body3-bold'}`"
                >{{ article.fields.category.fields.title }}
              </SlpTypography>
            </SlpButton>
            <span
              v-if="article.fields?.author && article.fields?.category"
              class="separator"
            ></span>
            <SlpButton
              v-if="article.fields?.author"
              :href="`/${article.fields?.author?.fields?.slug}/`"
              variant="tertiary"
              :disabled="disableAuthor"
            >
              <SlpTypography
                tag="span"
                :variant="`${disableAuthor ? 'body3' : 'body3-bold'}`"
              >
                {{ article.fields.author.fields.name }}
              </SlpTypography>
            </SlpButton>
          </div>
        </div>
        <SlpButton
          :href="`/${article.fields.slug}/`"
          variant="ghost"
          class="ts-articles__image"
          @mouseover.native="article.isHighlighted = true"
          @mouseleave.native="article.isHighlighted = false"
        >
          <img
            v-if="getArticleImage(article)"
            :src="getArticleImage(article)"
            :alt="getAlt(article)"
            loading="lazy"
          />
        </SlpButton>
      </div>
    </div>
    <SlpButton
      v-if="!showAll"
      class="ts-articles__all"
      variant="primary"
      @click.native="toggleArticles"
    >
      {{ $t('articles.browse') }}
    </SlpButton>
  </div>
</template>

<style scoped lang="scss">
.separator {
  border-left: 1px solid $color-surface-400;
  height: 12px;
  margin: 0 $spacing-8;
}

.ts-articles {
  padding: $spacing-32 0;

  &__image {
    min-width: 100px;
    max-width: 100px;
    height: 100px;

    img {
      border-radius: 8px;
      width: 100%;
      max-height: 100px;
      height: 100%;
      object-fit: cover;
      overflow-clip-margin: unset;

      @media (width >= $breakpoint-md) {
        object-fit: unset;
      }
    }

    @media (min-width: $breakpoint-sm) {
      max-height: 100px;
      min-width: 186px;
      max-width: 186px;

      img {
        width: 100%;
        height: unset;
      }
    }
  }

  &__all {
    width: 100%;
    margin-top: $spacing-24;
    justify-content: center;
  }

  &__headline {
    padding: 0;
    text-align: start;

    &:hover {
      text-decoration-color: $color-text-link-100;
      color: $color-text-link-100;
    }

    &--active {
      color: $color-text-link-100;
      text-decoration-color: $color-text-link-100;
    }
  }

  &__item {
    border-top: 1px solid $color-surface-300;
    display: flex;
    justify-content: space-between;
    align-items: center;
    padding: $spacing-16 0;

    @media (width >= $breakpoint-md) {
      padding: $spacing-24;
    }

    &:last-of-type {
      border-bottom: 1px solid $color-surface-300;
    }
  }

  &__btn-group {
    display: flex;
    align-items: center;
    text-align: start;
    flex-wrap: wrap;

    .slp-btn {
      padding: 0;
      text-align: start;

      &:hover {
        color: $color-text-link-100;
        text-decoration-color: $color-text-link-100;
      }

      &-disabled {
        color: $color-text-300 !important;
        font-weight: $font-weight-normal !important;
      }
    }
  }
}
</style>
